#
# SchoolTool - common information systems platform for school administration
# Copyright (c) 2010 Shuttleworth Foundation
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
"""
Schoolyear data consistency hooks.
"""

from zope.component import adapts
from zope.container.interfaces import INameChooser
from zope.lifecycleevent.interfaces import IObjectAddedEvent

from schooltool.schoolyear.interfaces import ISchoolYear
from schooltool.schoolyear.subscriber import ObjectEventAdapterSubscriber
from schooltool.term.term import Term


class CreateOneDefaultTerm(ObjectEventAdapterSubscriber):
    adapts(IObjectAddedEvent, ISchoolYear)

    def __call__(self):
        schoolyear = self.object
        term = Term(schoolyear.title, schoolyear.first, schoolyear.last)
        namechooser = INameChooser(schoolyear)
        name = namechooser.chooseName('', term)
        schoolyear[name] = term
        # Make all days schooldays by default
        for date in term:
            term.add(date)
